package com.cirmuller.maidaddition.entity.sensor;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.cirmuller.maidaddition.configs.Config;
import com.cirmuller.maidaddition.entity.memory.MemoryRegistry;
import com.github.tartaricacid.touhoulittlemaid.entity.passive.EntityMaid;
import com.simibubi.create.content.kinetics.crank.HandCrankBlockEntity;
import java.util.Set;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Vec3i;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.ai.memory.MemoryModuleType;
import net.minecraft.world.entity.ai.sensing.Sensor;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.state.BlockState;
import org.jetbrains.annotations.Nullable;

public class HandCrankSensor extends Sensor<EntityMaid> {
  private static final int scanRate = ((Integer)Config.UPDATE_RATE.get()).intValue();
  
  public HandCrankSensor() {
    super(scanRate);
  }
  
  protected void doTick(ServerLevel serverLevel, EntityMaid entityMaid) {
    HandCrankBlockEntity handCrankBlockEntity = null;
    BlockPos pos = entityMaid.m_20097_();
    for (int i = 0; i <= entityMaid.getTask().searchRadius(entityMaid); i++) {
      HandCrankBlockEntity searchResult = searchHandCrankBlockEntity(serverLevel, (Vec3i)pos, i);
      if (searchResult != null) {
        handCrankBlockEntity = searchResult;
        break;
      } 
    } 
    entityMaid.m_6274_().m_21879_((MemoryModuleType)MemoryRegistry.HAND_CRANK_TARGET.get(), handCrankBlockEntity);
  }
  
  public Set<MemoryModuleType<?>> m_7163_() {
    return Set.of((MemoryModuleType)MemoryRegistry.HAND_CRANK_TARGET.get());
  }
  
  @Nullable
  private HandCrankBlockEntity searchHandCrankBlockEntity(ServerLevel serverLevel, Vec3i center, int radius) {
    int x = center.m_123341_();
    int y = center.m_123342_();
    int z = center.m_123343_();
    int xMin = x - radius;
    int xMax = x + radius;
    int yMin = y - radius;
    int yMax = y + radius;
    int zMin = z - radius;
    int zMax = z + radius;
    int i;
    for (i = xMin; i < xMax; i++) {
      for (int j = yMin; j < yMax; j++) {
        BlockPos pos = new BlockPos(i, j, zMin);
        BlockState blockState = serverLevel.m_8055_(pos);
        if (blockState.m_155947_()) {
          BlockEntity blockEntity = serverLevel.m_7702_(pos);
          if (blockEntity instanceof HandCrankBlockEntity) {
            HandCrankBlockEntity handCrankBlockEntity = (HandCrankBlockEntity)blockEntity;
            if (handCrankBlockEntity.inUse == 0)
              return handCrankBlockEntity; 
          } 
        } 
      } 
    } 
    for (i = zMin; i < zMax; i++) {
      for (int j = yMin; j < yMax; j++) {
        BlockPos pos = new BlockPos(xMax, j, i);
        BlockState blockState = serverLevel.m_8055_(pos);
        if (blockState.m_155947_()) {
          BlockEntity blockEntity = serverLevel.m_7702_(pos);
          if (blockEntity instanceof HandCrankBlockEntity) {
            HandCrankBlockEntity handCrankBlockEntity = (HandCrankBlockEntity)blockEntity;
            if (handCrankBlockEntity.inUse == 0)
              return handCrankBlockEntity; 
          } 
        } 
      } 
    } 
    for (i = xMax; i > xMin; i--) {
      for (int j = yMin; j < yMax; j++) {
        BlockPos pos = new BlockPos(i, j, zMax);
        BlockState blockState = serverLevel.m_8055_(pos);
        if (blockState.m_155947_()) {
          BlockEntity blockEntity = serverLevel.m_7702_(pos);
          if (blockEntity instanceof HandCrankBlockEntity) {
            HandCrankBlockEntity handCrankBlockEntity = (HandCrankBlockEntity)blockEntity;
            if (handCrankBlockEntity.inUse == 0)
              return handCrankBlockEntity; 
          } 
        } 
      } 
    } 
    for (i = zMax; i > zMin; i--) {
      for (int j = yMin; j < yMax; j++) {
        BlockPos pos = new BlockPos(xMin, j, i);
        BlockState blockState = serverLevel.m_8055_(pos);
        if (blockState.m_155947_()) {
          BlockEntity blockEntity = serverLevel.m_7702_(pos);
          if (blockEntity instanceof HandCrankBlockEntity) {
            HandCrankBlockEntity handCrankBlockEntity = (HandCrankBlockEntity)blockEntity;
            if (handCrankBlockEntity.inUse == 0)
              return handCrankBlockEntity; 
          } 
        } 
      } 
    } 
    for (i = xMin; i <= xMax; i++) {
      for (int j = zMin; j <= zMax; j++) {
        BlockPos pos = new BlockPos(i, yMax, j);
        BlockState blockState = serverLevel.m_8055_(pos);
        if (blockState.m_155947_()) {
          BlockEntity blockEntity = serverLevel.m_7702_(pos);
          if (blockEntity instanceof HandCrankBlockEntity) {
            HandCrankBlockEntity handCrankBlockEntity = (HandCrankBlockEntity)blockEntity;
            if (handCrankBlockEntity.inUse == 0)
              return handCrankBlockEntity; 
          } 
        } 
      } 
    } 
    for (i = xMin + 1; i < xMax; i++) {
      for (int j = zMin + 1; j < zMax; j++) {
        BlockPos pos = new BlockPos(i, yMin, j);
        BlockState blockState = serverLevel.m_8055_(pos);
        if (blockState.m_155947_()) {
          BlockEntity blockEntity = serverLevel.m_7702_(pos);
          if (blockEntity instanceof HandCrankBlockEntity) {
            HandCrankBlockEntity handCrankBlockEntity = (HandCrankBlockEntity)blockEntity;
            if (handCrankBlockEntity.inUse == 0)
              return handCrankBlockEntity; 
          } 
        } 
      } 
    } 
    return null;
  }
}
